%{?python_enable_dependency_generator}

%if (0%{?rhel} && 0%{?rhel} <= 7) || (0%{?fedora} && 0%{?fedora} <= 28)
# Since the Python 3 stack in EPEL is missing too many dependencies,
# we're sticking with Python 2 there for now.
# And Pagure in Fedora 28 and lower is built for Python 2...
%global __python %{__python2}
%global python_pkgversion 2
%else
# Default to Python 3 when F29+ or not EL
%global __python %{__python3}
%global python_pkgversion %{python3_pkgversion}
%endif

# For now, to keep behavior consistent (and matching pagure package)
%global _python_bytecompile_extra 1

Name:               pagure-dist-git
Version:            0.12
Release:            1%{?dist}
Summary:            Pagure gitolite plugin for Fedora's dist-git setup

License:            GPLv2+
URL:                https://pagure.io/pagure-dist-git
Source0:            https://releases.pagure.org/%{name}/%{name}-%{version}.tar.gz
BuildArch:          noarch

BuildRequires:      python%{python_pkgversion}-devel
BuildRequires:      python%{python_pkgversion}-setuptools

%if %{undefined python_enable_dependency_generator}
Requires:           python%{python_pkgversion}-pdc-client

Requires:           pagure >= 3.90
%endif

# This is actually an extension to Pagure itself and can't be built this way
# So we're changing it all up..
Obsoletes:          python-%{name} < 0.12
Obsoletes:          python2-%{name} < 0.12
Obsoletes:          python3-%{name} < 0.12
# However, we'll preserve some backwards compatibility here
Provides:           python%{python_pkgversion}-%{name} = %{version}-%{release}

%description
Since 3.0 pagure offers a way to customize the creation and compilation the
of the gitolite configuration file.

This project hosts the logic to generate gitolite's configuration file for
dist-git which has a different access model than regular projects on pagure
(for example, forced pushed is forbidden).


%prep
%autosetup -n %{name}-%{version}

%build
%py_build

%install
%py_install


# Install the custom template/theme
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/pagure_dist_git/template/
install -p -m 644 template/*.html $RPM_BUILD_ROOT/%{_datadir}/pagure_dist_git/template/

# Install the customized static files or our own
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/pagure_dist_git/static/
install -p -m 644 static/pagure-logo.png $RPM_BUILD_ROOT/%{_datadir}/pagure_dist_git/static/

# Install the different cron job scripts
mkdir -p $RPM_BUILD_ROOT/%{_libexecdir}/pagure-dist-git/
install -p -m 644 scripts/*.py $RPM_BUILD_ROOT/%{_libexecdir}/pagure-dist-git/

# The tests require network access, so don't run them.
#%%check
#%%{__python} setup.py test

%files
%doc README.rst
%license LICENSE
%{python_sitelib}/dist_git_auth.py*
%{python_sitelib}/pagure_dist_git-%{version}*
%if 0%{?python_pkgversion} != 2
%{python3_sitelib}/__pycache__/dist_git_auth*.pyc
%endif
%{_datadir}/pagure_dist_git/
%{_libexecdir}/pagure-dist-git/

%changelog
* Tue Sep 18 2018 Neal Gompa <ngompa13@gmail.com> - 0.12-1
- Rework and simplify packaging to mimic pagure's package setup
- Rebase to the latest version of the extension
- Drop Python 2 build for F29+ (#1627133)

* Mon Sep 10 2018 Ralph Bean <rbean@redhat.com> - 0.1-4
- Enable python 3.

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Fri Jun 30 2017 Ralph Bean <rbean@redhat.com> - 0.1-1
- Initial packaging for Fedora
